//**********************************************************************
//  DLMS/COSEM components
//
//  i-cube, Christian Aymon, 1966 Ayent, Switzerland
//          www.icube.ch
//
// (C)Copyright 2001-2016
//**********************************************************************
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   Com.cpp
 * Author: Christian
 * 
 * Created on August 5, 2016, 9:53 AM
 */

#include "Com.h"
#include <errno.h>
#include <fcntl.h> 
#include <string.h>
#include <termios.h>
#include <unistd.h>
#include <cstdio>
#include "sys/time.h"

Com::Com() {
}

Com::Com(const Com& orig) {
}

Com::~Com() {
}

bool Com::Open(char *pComPortName) {
    fd = open(pComPortName, O_RDWR | O_NOCTTY | O_SYNC);
    if (fd < 0) {
        snprintf(ErrorMessage, sizeof (ErrorMessage), "error %d opening %s: %s", errno, pComPortName, strerror(errno));
        return false;
    }
    else
        return true;
}

void Com::Close() {
    close(fd);
}

bool Com::Configure(int Baud) {
    struct termios tty;
    memset(&tty, 0, sizeof tty);
    if (tcgetattr(fd, &tty) != 0) {
        snprintf(ErrorMessage, sizeof (ErrorMessage), "error %d from tcgetattr", errno);
        return false;
    }
    cfmakeraw(&tty);
    cfsetospeed(&tty, Baud);
    cfsetispeed(&tty, Baud);
    tty.c_cc[VTIME] = 100; // 10 seconds read timeout
    tty.c_cc[VMIN] = 0;
/*
    tty.c_cflag = (tty.c_cflag & ~CSIZE) | CS8; // 8-bit chars
    // disable IGNBRK for mismatched speed tests; otherwise receive break
    // as \000 chars
    tty.c_iflag &= ~IGNBRK; // disable break processing
    tty.c_lflag = 0; // no signaling chars, no echo,
    // no canonical processing
    tty.c_oflag = 0; // no remapping, no delays
    tty.c_cc[VTIME] = 100; // 10 seconds read timeout

    tty.c_iflag &= ~(IXON | IXOFF | IXANY); // shut off xon/xoff ctrl

    tty.c_cflag |= (CLOCAL | CREAD); // ignore modem controls,
    // enable reading
    tty.c_cflag &= ~(PARENB | PARODD); // shut off parity
    // tty.c_cflag |= parity;
    tty.c_cflag &= ~CSTOPB;
    tty.c_cflag &= ~CRTSCTS;
*/
    if (tcsetattr(fd, TCSANOW, &tty) != 0) {
        snprintf(ErrorMessage, sizeof (ErrorMessage), "error %d from tcsetattr", errno);
        return false;
    }
    return true;
}

void Com::Purge()
{
    // do nothing
}

bool Com::GetByte(unsigned char * pData) 
{
    return (read (fd, pData, 1) == 1);
}

int Com::GetLastError()
{
    return errno;
}

unsigned int Com::GetTickCount() 
{
    struct timeval tv;
    if (gettimeofday(&tv, NULL) != 0)
        return 0;

    return (tv.tv_sec * 1000) + (tv.tv_usec / 1000);
}

void Com::SetErrorMessage(char *s) {
    strncpy(ErrorMessage, s, sizeof (ErrorMessage));
}

/*
 #include <errno.h>
#include <fcntl.h> 
#include <string.h>
#include <termios.h>
#include <unistd.h>

int
set_interface_attribs (int fd, int speed, int parity)
{
        struct termios tty;
        memset (&tty, 0, sizeof tty);
        if (tcgetattr (fd, &tty) != 0)
        {
                error_message ("error %d from tcgetattr", errno);
                return -1;
        }

        cfsetospeed (&tty, speed);
        cfsetispeed (&tty, speed);

        tty.c_cflag = (tty.c_cflag & ~CSIZE) | CS8;     // 8-bit chars
        // disable IGNBRK for mismatched speed tests; otherwise receive break
        // as \000 chars
        tty.c_iflag &= ~IGNBRK;         // disable break processing
        tty.c_lflag = 0;                // no signaling chars, no echo,
                                        // no canonical processing
        tty.c_oflag = 0;                // no remapping, no delays
        tty.c_cc[VMIN]  = 0;            // read doesn't block
        tty.c_cc[VTIME] = 5;            // 0.5 seconds read timeout

        tty.c_iflag &= ~(IXON | IXOFF | IXANY); // shut off xon/xoff ctrl

        tty.c_cflag |= (CLOCAL | CREAD);// ignore modem controls,
                                        // enable reading
        tty.c_cflag &= ~(PARENB | PARODD);      // shut off parity
        tty.c_cflag |= parity;
        tty.c_cflag &= ~CSTOPB;
        tty.c_cflag &= ~CRTSCTS;

        if (tcsetattr (fd, TCSANOW, &tty) != 0)
        {
                error_message ("error %d from tcsetattr", errno);
                return -1;
        }
        return 0;
}

void
set_blocking (int fd, int should_block)
{
        struct termios tty;
        memset (&tty, 0, sizeof tty);
        if (tcgetattr (fd, &tty) != 0)
        {
                error_message ("error %d from tggetattr", errno);
                return;
        }

        tty.c_cc[VMIN]  = should_block ? 1 : 0;
        tty.c_cc[VTIME] = 5;            // 0.5 seconds read timeout

        if (tcsetattr (fd, TCSANOW, &tty) != 0)
                error_message ("error %d setting term attributes", errno);
}


...
char *portname = "/dev/ttyUSB1"
 ...
int fd = open (portname, O_RDWR | O_NOCTTY | O_SYNC);
if (fd < 0)
{
        error_message ("error %d opening %s: %s", errno, portname, strerror (errno));
        return;
}

set_interface_attribs (fd, B115200, 0);  // set speed to 115,200 bps, 8n1 (no parity)
set_blocking (fd, 0);                // set no blocking

write (fd, "hello!\n", 7);           // send 7 character greeting

usleep ((7 + 25) * 100);             // sleep enough to transmit the 7 plus
                                     // receive 25:  approx 100 uS per char transmit
char buf [100];
int n = read (fd, buf, sizeof buf);  // read up to 100 characters if ready to read
 */

